using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Categories;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface ICategoryRepository
    {
        Task<BaseResult> Add(CategoryElastic Category);

        Task<BaseResult> AddManyAsync(IEnumerable<CategoryElastic> Categorys);

        Task<SmartTableResult<CategoryElastic>> Search(BoolQueryDescriptor<CategoryElastic> query);

        Task<SmartTableResult<CategoryElastic>> GetByIds(List<long> ids);

        Task<SmartTableResult<CategoryElastic>> GetAll();
    }

    public class CategoryRepository : ICategoryRepository
    {
        private readonly ElasticIndex<CategoryElastic> _dbContext;

        public CategoryRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<CategoryElastic>(settings.Value.ClusterUrl, "inventorycategory");
        }

        public async Task<SmartTableResult<CategoryElastic>> Search(BoolQueryDescriptor<CategoryElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<BaseResult> Add(CategoryElastic Category)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Category);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<CategoryElastic> Categorys)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Categorys);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<CategoryElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<CategoryElastic>();
            var idsQ = new QueryContainerDescriptor<CategoryElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        public async Task<SmartTableResult<CategoryElastic>> GetAll()
        {
            var query = new BoolQueryDescriptor<CategoryElastic>();
            var isdeletedQ = new QueryContainerDescriptor<CategoryElastic>();
            isdeletedQ.Terms(t => t.Field(f => f.IsDeleted).Terms(false));
            query.Filter(f => isdeletedQ);
            return await _dbContext.Search(query);
        }
    }
}